% this script establishes scatter diagrams for Haltenbanken and the Barents
% Sea

clc
clear
close all

run('scatter_diagram.m')
run('dir_scatter.m')

run('hindcast_barents.m')
run('scatter_diagram_barents.m')
run('dir_scatter_barents.m')

figure()
bar(perc_h);
axis([0 13 0 25])
xlabel('Sectors','Fontsize',15);ylabel('Distribution of waves, %','Fontsize',15);
h=legend('Haltenbanken');
set(h,'FontSize',15)
grid on
width=15.875;
height=0.8*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','perc_h.pdf')

figure()
bar(perc_b);
axis([0 13 0 20])
xlabel('Sectors','Fontsize',15);ylabel('Distribution of waves, %','Fontsize',15);
h=legend('Barents Sea');
set(h,'FontSize',15)
grid on
width=15.875;
height=0.8*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','perc_b.pdf')