% DIRECTIONAL SCATTER DIAGRAM
% area: Haltenbanken

global hs tp dir num_tp_intervals num_hs_intervals scatter_dir sector_data
global scatter_sectors perc_h

dir_s=zeros(length(dir),12*3); % data for all 12 sectors: hs, tp and dir

for i=1:12 % 12 sectors
    for j=1:length(dir)
        if i==1 % sector 1: 345-015 degrees
            if (dir(j)>345) || (dir(j)<=15)
                dir_s(j,1)=hs(j);
                dir_s(j,2)=tp(j);
                dir_s(j,3)=dir(j);
            else
                dir_s(j,3)=0;
            end
        else % sectors 2-12
            if ((dir(j)>15+(30*(i-2))) && (dir(j)<=(45+(30*(i-2)))))
                dir_s(j,i*2+(i-2))=hs(j);
                dir_s(j,i*2+(i-1))=tp(j);
                dir_s(j,i*2+(i))=dir(j);
            else
                dir_s(j,i*3)=0;
            end
        end
    end
end

scatter_sectors=zeros(num_hs_intervals+1, num_tp_intervals+1,12);

for k=1:12
    % creating local matrix S for sector nr. 'i'
    S=dir_s(:,[(1+((k-1)*3)) (2+((k-1)*3)) (3+((k-1)*3))]);
    % removing values equal to zero
    ix=find(not(S(:,3)));
    S(ix,:)=[];
    sector_data{k}=S(:,:); % hs,tp and dir for each sector
    
    hs_interval_size = 1;    
    
    for l=1:length(S);
        hs_interval = ceil(S(l,1) / hs_interval_size);
        scatter_sectors(hs_interval, ceil(S(l,2)),k) = scatter_sectors(hs_interval, ceil(S(l,2)),k)+1;
    end 
    for i=1:num_hs_intervals
        scatter_sectors(i,end,k)=sum(scatter_sectors(i,:,k)); 
    end
    for i=1:num_tp_intervals
       scatter_sectors(end,i,k)=sum(scatter_sectors(:,i,k)); 
    end
    scatter_sectors(end,end,k)=sum(scatter_sectors(:,end,k));
    scatter_dir{k}=scatter_sectors(:,:,k);
end

% calculating percentage of occurence for each sector
perc_h=zeros(1,12);
for p = 1:12
    perc_h(p) = scatter_sectors(end,end,p)/166053; 
end

perc_h=perc_h*100;

    
    
    
    
    
    
    