% DIRECTIONAL SCATTER DIAGRAM for BARENTS SEA

global hs_b tp_b dir_b num_tp_intervals_b num_hs_intervals_b scatter_dir_b sector_data_b
global scatter_sectors_b perc_b 

dir_b_s=zeros(length(dir_b),12*3); % data for all 12 sectors: hs_b, tp_b and dir_b

for i=1:12 % 12 sectors
    for j=1:length(dir_b)
        if i==1 % sector 1: 345-015 degrees
            if (dir_b(j)>345) || (dir_b(j)<=15)
                dir_b_s(j,1)=hs_b(j);
                dir_b_s(j,2)=tp_b(j);
                dir_b_s(j,3)=dir_b(j);
            else
                dir_b_s(j,3)=0;
            end
        else % sectors 2-12
            if ((dir_b(j)>15+(30*(i-2))) && (dir_b(j)<=(45+(30*(i-2)))))
                dir_b_s(j,i*2+(i-2))=hs_b(j);
                dir_b_s(j,i*2+(i-1))=tp_b(j);
                dir_b_s(j,i*2+(i))=dir_b(j);
            else
                dir_b_s(j,i*3)=0;
            end
        end
    end
end

scatter_sectors_b=zeros(num_hs_intervals_b+1, num_tp_intervals_b+1,12);

for k=1:12
    % creating local matrix S for sector nr. 'i'
    S=dir_b_s(:,[(1+((k-1)*3)) (2+((k-1)*3)) (3+((k-1)*3))]);
    % removing values equal to zero
    ix=find(not(S(:,3)));
    S(ix,:)=[];
    sector_data_b{k}=S(:,:); % hs_b,tp_b and dir_b for each sector
    
    hs_b_interval_size = 1;    
    
    for l=1:length(S);
        hs_b_interval = ceil(S(l,1) / hs_b_interval_size);
        scatter_sectors_b(hs_b_interval, ceil(S(l,2)),k) = scatter_sectors_b(hs_b_interval, ceil(S(l,2)),k)+1;
    end 
    for i=1:num_hs_intervals_b
        scatter_sectors_b(i,end,k)=sum(scatter_sectors_b(i,:,k)); 
    end
    for i=1:num_tp_intervals_b
       scatter_sectors_b(end,i,k)=sum(scatter_sectors_b(:,i,k)); 
    end
    scatter_sectors_b(end,end,k)=sum(scatter_sectors_b(:,end,k));
    scatter_dir_b{k}=scatter_sectors_b(:,:,k);
end

% calculating percentage of occurence for each sector
perc_b=zeros(1,12);
for p = 1:12
    perc_b(p) = scatter_sectors_b(end,end,p)/166053; 
end

perc_b=perc_b*100;