% OMNI DIRECTIONAL SCATTER DIAGRAM
% area: Haltenbanken

global hs tp hs_max tp_max n_obs dir num_tp_intervals num_hs_intervals scatter

% fetching Hs, direction of Hs and Tp from modified Hindcast file
% Heidrun_WAM10_6529N_0732E_modified.txt :
fid = fopen('Hindcast/Heidrun_WAM10_6529N_0732E_mod.txt','r');
A = fscanf(fid,'%f %f %f %f',[4,inf])';
fclose(fid);

n_obs = length(hs);
hs = A(:,2); hs_max = max(hs);
tp = A(:,3); tp_max = max(tp);
dir = A(:,4);

% creating a scatter diagram: rows of Hs and columns of Tp
num_tp_intervals = ceil(tp_max);
hs_interval_size = 1;
num_hs_intervals = ceil(hs_max / hs_interval_size);
scatter=zeros(num_hs_intervals+1, num_tp_intervals+4);

for i=1:n_obs
    hs_interval = ceil(hs(i) / hs_interval_size);
    scatter(hs_interval, ceil(tp(i))) = scatter(hs_interval, ceil(tp(i)))+1;
end

% sum of Hs-rows and Tp-columns:
scatter((ceil(max(hs))*2)+1,:)=sum(scatter(:,:));
scatter(:,ceil(max(tp))+1)=sum(scatter(:,:)');

% column for cumulative no. of observations
cs = length(scatter(1,:))-2; 
scatter(1,cs)=scatter(1,cs-1); %filling first row
for i=2:1:length(scatter(:,1))-2
    scatter(i,cs) = scatter(i,cs-1) + scatter(i-1,cs);
end







    
    
    
    
    
    


