% this script runs the following scripts:

    % average_duration.m  : this script establishes the average duration of
    % calms/storms
    
    % average_duration_weibull.m  : this script establishes the
    % distribution of the duration of calms by a probability paper
    
    % moment_estimator.m  : this script establishes the distribution of
    % the duration of calms by the method of moments
    
    % monthly_calm.m  : this script establishes monthly distributions of
    % the duration of calms by method of moments
    
    % monthly_storm.m  : this script establishes monthly distributions of
    % the duration of storms by method of moments
    
    % several of these scripts employ functions:
        % years.m
        % durationz.m 
        % durationz2.m
        % prob_under_t_func.m
    
clc
clear
close all
    
run('average_duration.m')
run('average_duration_weibull.m')
run('moment_estimator.m')
run('monthly_calm.m')
run('monthly_storm.m')


tablez = years(:,12,53);
tablez(tablez==0)=[];

figure()
plot(1:length(tablez(:,1)),tablez,'-k.','MarkerSize',7)
xlabel('Observation nr.','Fontsize',15);ylabel('H_s','Fontsize',15);
width=15.875;
height=0.7*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','december.pdf')


