% AVERAGE DURATION OF CALM AND STORMY PERIODS, HALTENBANKEN

clear

th_hs = 2; % threshold value Hs'

% fetching sorted hindcast data by using function years.m
years = years();
nr_of_years = length(years(1,1,:));

average_calm = zeros(1,12,58); average_storm = zeros(1,12,58);
nr_calm_hrs_months = zeros(1,12); nr_storm_hrs_months = zeros(1,12);
nr_calms_months = zeros(1,12); nr_storms_months = zeros(1,12);
tot_nr_of_calms = 0; tot_nr_of_hours = 0; hrs_calms_month = 0;
tot_nr_of_obs = 0; nr_years_per_month = zeros(1,12);
calms_months = cell(12,200); 
for i=1:nr_of_years
    for j=1:12
        first_calm = 1; first_storm = 1;
        last_value_was_calm = []; last_value_was_storm = [];
        k = 1; l = 1;
        
            tmp_col = (years(:,j,i));
            calms = zeros(length(tmp_col),1); storms = zeros(length(tmp_col),1);
            if ~any(tmp_col) == 1
            else
                tmp_col(tmp_col==0)=[];
                tot_nr_of_obs = tot_nr_of_obs + length(tmp_col);
                for m = 1:length(tmp_col)
                    if tmp_col(m) <= th_hs 
                        if first_calm == 1
                            calms(k) = calms(k) + 3;
                            first_calm = 0;
                        else
                            if last_value_was_calm == 1
                                calms(k) = calms(k) + 3;
                            else
                                k = k+1; % new calm begins
                                calms(k) = calms(k) + 3;
                            end
                        end
                        last_value_was_calm = 1;
                        last_value_was_storm = 0;
                    else
                        if first_storm == 1
                            storms(l) = storms(l) + 3;
                            first_storm = 0;
                        else 
                            if last_value_was_storm == 1
                                storms(l) = storms(l) + 3;
                            else
                                l = l+1; % new storm begins
                                storms(l) = storms(l) + 3;
                            end
                        end
                        last_value_was_calm = 0;
                        last_value_was_storm = 1;    
                    end

                    if isempty(last_value_was_storm) == 1;
                        last_value_was_storm = 0;
                    end

                    if isempty(last_value_was_calm) == 1;
                        last_value_was_calm = 0;
                    end
                end
                
                if ~any(calms) == 1;
                else
                    calms(calms == 0) = []; storms(storms == 0) = [];
                    calms_months{j,i} = calms;  
                    
                    hrs_calms_month = sum(calms); 
                    nr_of_calms = length(calms); 
                    hrs_storms_month = sum(storms);
                    nr_of_storms = length(storms);

                    tot_nr_of_hours = tot_nr_of_hours + hrs_calms_month;
                    tot_nr_of_calms = tot_nr_of_calms + nr_of_calms;

                    avg_duration_calm = hrs_calms_month / nr_of_calms;
                    average_calm(1,j,i) = avg_duration_calm;
                    
                    avg_duration_storm = hrs_storms_month / nr_of_storms;
                    average_storm(1,j,i) = avg_duration_storm;
                    
                    nr_calm_hrs_months(j) = nr_calm_hrs_months(j) + hrs_calms_month;
                    nr_storm_hrs_months(j) = nr_storm_hrs_months(j) + hrs_storms_month;
                    nr_calms_months(j) = nr_calms_months(j) + nr_of_calms;
                    nr_storms_months(j) = nr_storms_months(j) + nr_of_storms;

                    nr_years_per_month(j) = nr_years_per_month(j) + 1;
                end
            end
    end
end

if tot_nr_of_obs ~= 166053
    disp('Missing data')
end

average_dur_of_a_calm = tot_nr_of_hours / tot_nr_of_calms;
monthly_average_dur_calm = nr_calm_hrs_months./nr_calms_months;
monthly_average_dur_storm = nr_storm_hrs_months./nr_storms_months;

calmz = zeros(300,12);
nr_calms_months2 = zeros(1,12);
for i = 1:12
    starting = 1;
    first_iteration = 1;
    for j = 1:58
        tab = calms_months{i,j};
        if isempty(tab) == 1
        else
            if first_iteration == 1
                ending = length(tab); 
                calmz((1:1:ending),i) = tab;
                starting = ending + 1;
                first_iteration = 0;
            else
                ending = starting + (length(tab)-1);
                calmz((starting:1:ending),i) = tab;
                starting = ending + 1;
            end
        end
    end
    col = calmz(:,i);
    col(col==0) = [];
    nr_calms_months2(i) = length(col);
end

% determning worst, average and best months
all_average_2D_calm = zeros(nr_of_years,12);
all_average_2D_storm = zeros(nr_of_years,12);
for a = 1:nr_of_years
    for b = 1:12
        all_average_2D_calm(a,b) = average_calm(1,b,a);
        all_average_2D_storm(a,b) = average_storm(1,b,a);
    end
end
worst_months_calm = zeros(1,12); worst_months_storm = zeros(1,12); 
best_months_calm = zeros(1,12); best_months_storm = zeros(1,12);
for c = 1:12
    tmp_row_calm = all_average_2D_calm(:,c);
    tmp_row_calm(tmp_row_calm==0)=[];
    tmp_row_calm(isnan(tmp_row_calm)) = [];
    
    tmp_row_storm = all_average_2D_storm(:,c);
    tmp_row_storm(tmp_row_storm==0)=[];
    tmp_row_storm(isnan(tmp_row_storm)) = [];
    
    worst_months_calm(c) = min(tmp_row_calm);
    best_months_calm(c) = max(tmp_row_calm);
    
    best_months_storm(c) = min(tmp_row_storm);
    worst_months_storm(c) = max(tmp_row_storm);
end
a= [12.6132075471698 24.5301204819277;12.7885714285714 28.5189873417722;16.0714285714286 33.7087378640777;19.4138851802403 44.0046728971963; 27.9123006833713 72.3777239709443; 32.6982035928144 91.5171428571429; 34.3691037735849 110.022580645161; 34.4132841328413 99.8571428571429; 21.5294117647059 52.9746835443038; 15.9593908629442 37.1101694915254;14.6882217090069 30.2483443708609; 12.7406250000000 25.5500000000000];

% PLOTTING
figure()
bar(monthly_average_dur_calm);
grid on
xlabel('Months','Fontsize',15);ylabel('Av. dur. of Calms (H_s''=2 m) [hours]','Fontsize',15);
% legend('Haltenbanken');
width=15.875;
height=0.6*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','avg_dur_calm_2.pdf')

figure()
bar(monthly_average_dur_storm);
grid on
xlabel('Months','Fontsize',15);ylabel('Av. dur. of Storms (H_s''=2 m) [hours]','Fontsize',15);
% legend('Haltenbanken');
width=15.875;
height=0.6*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','avg_dur_storm_2.pdf')

figure() 
x=1:12;
plot(x,worst_months_calm,'sr',x,monthly_average_dur_calm,'sb',x,best_months_calm,'sg')
grid on
% axis([0 13 0 1000])
legend('Worst months','Average months','Best months','Location','Northwest','Fontsize',14)
xlabel('Months','Fontsize',15);ylabel('Calms (H_s''=2 m) [hours]','Fontsize',15);
width=15.875;
height=0.6*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','wmb_calm_2_halten.pdf')

figure() 
x=1:12;
plot(x,worst_months_storm,'sr',x,monthly_average_dur_storm,'sb',x,best_months_storm,'sg')
grid on
% axis([0 13 0 80])
legend('Worst months','Average months','Best months','Location','North','Fontsize',14)
xlabel('Months','Fontsize',15);ylabel('Storms (H_s''=2 m) [hours]','Fontsize',15);
width=15.875;
height=0.6*width;
set(gcf,'defaulttextinterpreter','latex',...
                'PaperUnits','centimeters','PaperSize',[width height],...
                'PaperPosition',[0,0,width,height],'Units','centimeters',...
                'Position',[1,10,width,height]);
print('-dpdf','-r500','wmb_storm_2_halten.pdf')



% % Hs' = 5 m!!!
% figure()
% bar(monthly_average_dur_calm);
% grid on
% xlabel('Months','Fontsize',15);ylabel('Av. dur. of Calms (H_s''=5 m) [hours]','Fontsize',15);
% % legend('Haltenbanken');
% width=15.875;
% height=0.6*width;
% set(gcf,'defaulttextinterpreter','latex',...
%                 'PaperUnits','centimeters','PaperSize',[width height],...
%                 'PaperPosition',[0,0,width,height],'Units','centimeters',...
%                 'Position',[1,10,width,height]);
% print('-dpdf','-r500','avg_dur_calm_5.pdf')
% 
% figure()
% bar(monthly_average_dur_storm);
% grid on
% xlabel('Months','Fontsize',15);ylabel('Av. dur. of Storms (H_s''=5 m) [hours]','Fontsize',15);
% % legend('Haltenbanken');
% width=15.875;
% height=0.6*width;
% set(gcf,'defaulttextinterpreter','latex',...
%                 'PaperUnits','centimeters','PaperSize',[width height],...
%                 'PaperPosition',[0,0,width,height],'Units','centimeters',...
%                 'Position',[1,10,width,height]);
% print('-dpdf','-r500','avg_dur_storm_5.pdf')
% 
% figure() 
% x=1:12;
% plot(x,worst_months_calm,'sr',x,monthly_average_dur_calm,'sb',x,best_months_calm,'sg')
% grid on
% axis([0 13 0 1000])
% legend('Worst months','Average months','Best months','Location','Northwest','Fontsize',14)
% xlabel('Months','Fontsize',15);ylabel('Calms (H_s''=5 m) [hours]','Fontsize',15);
% width=15.875;
% height=0.6*width;
% set(gcf,'defaulttextinterpreter','latex',...
%                 'PaperUnits','centimeters','PaperSize',[width height],...
%                 'PaperPosition',[0,0,width,height],'Units','centimeters',...
%                 'Position',[1,10,width,height]);
% print('-dpdf','-r500','wmb_calm_5_halten.pdf')
% 
% figure() 
% x=1:12;
% plot(x,worst_months_storm,'sr',x,monthly_average_dur_storm,'sb',x,best_months_storm,'sg')
% grid on
% axis([0 13 0 80])
% legend('Worst months','Average months','Best months','Location','North','Fontsize',14)
% xlabel('Months','Fontsize',15);ylabel('Storms (H_s''=5 m) [hours]','Fontsize',15);
% width=15.875;
% height=0.6*width;
% set(gcf,'defaulttextinterpreter','latex',...
%                 'PaperUnits','centimeters','PaperSize',[width height],...
%                 'PaperPosition',[0,0,width,height],'Units','centimeters',...
%                 'Position',[1,10,width,height]);
% print('-dpdf','-r500','wmb_storm_5_halten.pdf')
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% figure()
% bar(a);
% xlabel('Months','Fontsize',14);ylabel('Average \tau_c [hours]','Fontsize',14);
% legend('Average \tau_c, roll considered','Average \tau_c, roll not considered','Location','northeast')
% axis([0 14 0 140])
% text(0.3,130,'H_s^{''} = 2 m','Fontsize',12)
% text(0.3,117,'\eta_{4_c} = 4 deg','Fontsize',12)
% grid on
% width=15.875;
% height=0.6*width;
% set(gcf,'defaulttextinterpreter','latex',...
%                 'PaperUnits','centimeters','PaperSize',[width height],...
%                 'PaperPosition',[0,0,width,height],'Units','centimeters',...
%                 'Position',[1,10,width,height]);
% print('-dpdf','-r500','av_calm_both.pdf')

    
    
    
    