% This script establishes limiting pairs of (Hs,Tp) by evaluating the standard deviation sigma_n3 of the response
% spectrum. The response spectrum is found by Sn3(w) = RAO^2 * S(w).
% Results are plotted in a figure which shows acceptable pairs of Hs and Tp
% together with a 10 year contour plot for Haltenbanken

% the script runs the following scripts
    % lonowe.m
    % longormal.m  : these establishes jpdf
    % critical_heave.m  : establishes acceptable pairs of Hs and Tp
    % res_contour.m  : establishes contour
    
clc
clear
close all

run('lonowe.m')
run('lognormal.m')
run('critical_heave.m')
run('res_contour.m')


