% This script simulates a marine operation by employing the
% hindcast data directly. Simulation begins in the first entry of each
% month. First, the hindcast data is fetched by the function years.m 
% Secondly, the script loops through all months, employing the script
% mar_op_func.m, which performs the simulation.

global table2 op_durations2

op_durations2 = cell(1,12);

years = years();

% three equal intervals, constant threshold Hs', two breaks
dur = [24 24 24];
th = [2 2 2];
nr_breaks = 2;
break_time = 3;


average_op_time = zeros(1,12); nr_impossible_months = zeros(1,12); nr_imp_perc = zeros(1,12);
for i = 1:12
    [op_durations2{i},average_op_time(i),nr_impossible_months(i),nr_imp_perc(i)] = mar_op_hindcast_f(years,dur,th,i,nr_breaks,break_time);
end

table2 = zeros(3,12);
table2(1,:) = average_op_time;
table2(2,:) = nr_impossible_months;
table2(3,:) = nr_imp_perc;

