% This script simulates a marine operation by using the distributions for
% the duration of calms and storms. 

global table1 op_durations1

op_durations1 = cell(1,12);

years = years(); 
th_hs = 2; % threshold Hs'

dur = [24 24 24];
nr_breaks = 2; break_time = 3;

nr_simulations = 10000;

% fetching monthly parameters for distribution of duration of calms and storms
parameters_calm = monthly_calms_func(years,th_hs);
parameters_storm = monthly_storms_func(years,th_hs);
average_op_time = zeros(1,12); nr_impossible_months = zeros(1,12); nr_imp_perc = zeros(1,12);
for i = 1:12
    [op_durations1{i},average_op_time(i),nr_impossible_months(i),nr_imp_perc(i)] = mar_op_weibull_f(i,parameters_calm,parameters_storm,dur,nr_breaks,break_time,nr_simulations);
end

table1 = zeros(3,12);
table1(1,:) = average_op_time;
table1(2,:) = nr_impossible_months;
table1(3,:) = nr_imp_perc;