function [op_durations,average_op_time,nr_impossible_months,nr_imp_perc] = mar_op_weibull_f(month,parameters_calm,parameters_storm,dur,nr_breaks,break_time,nr_simulations)

op_durations = zeros(nr_simulations,1);

days_in_months = [31 28 29 30 31 30 31 31 30 31 30 31];

    for i = 1 : nr_simulations
        total_time = 0;
        time_left = sum(dur)+(nr_breaks*break_time);

        while time_left > 0
            if total_time > (days_in_months(month)*24)
                break
            else
                tau_c = parameters_calm(1,month) * (-log(1-rand(1)))^(1/parameters_calm(2,month));
                time_left_tmp = time_left;
                time_left = time_left - tau_c;
                if time_left < 0 % if op is finished
                    total_time = total_time + time_left_tmp;
                else
                    total_time = total_time + tau_c;
                end
                if time_left > 0
                    tau_s = parameters_storm(1,month) * (-log(1-rand(1)))^(1/parameters_storm(2,month));
                    total_time = total_time + tau_s;
                end
            end
        end

        if total_time > (days_in_months(month)*24)
            op_durations(i) = 0;
        else
            op_durations(i) = total_time;
        end
    end
    
    nr_impossible_months = length(find(op_durations == 0));
    nr_imp_perc = nr_impossible_months/nr_simulations;
    
    op_durations(op_durations==0) = [];
    average_op_time = mean(op_durations);
    
end

        
        
        
        
        
        
        