% SPECTRUM FUNCTION



function S = spectrum(Hs,Tp,w)

% wave spectrum, JONSWAP

% lol = 0 + (1-0).*rand(1000,1);
% n=length(lol);
% w=sort(lol);

% w = (linspace(0,2,n_omega))';
n = length(w);

g = 9.81;

% spectral peak frequency
wp = (2*pi)/Tp;


sigma = zeros(n,1);

for i=1:n
    if w(i) <= wp
        sigma(i) = 0.07;
    else
        sigma(i) = 0.09;
    end
end

S=zeros(1,n);

gamma = 42.2 * ((2*pi*Hs)/(g*Tp^2))^(6/7); 
ledd1 = (1/(2*pi)) * 0.3125 * Hs^2 * Tp;
ledd4 = 1-(0.287*log(gamma));

for i = 1:n
    ledd2(i) = (w(i)./wp)^(-5);
    ledd3(i) = exp(-1.25*(w(i)/wp)^(-4));
    ledd5(i) = exp(-0.5*((w(i)-wp)/(wp*sigma(i)))^2);
    S(i) = ledd1*ledd2(i)*ledd3(i)*ledd4*(gamma^ledd5(i));
    
end


% gamma = 42.2 * ((2*pi*Hs)/(g*Tp^2))^(6/7);
% S = (1/(2*pi)) * 0.3125 * Hs^2 * Tp .* (w./wp).^(-5) .*exp(-1.25*(w./wp).^(-4)) .* (1-(0.287 * log(gamma))) .* gamma.^(-0.5*((w-wp)./(sigma.*wp)).^2);



% plot(w,S)
% 
% % checking if peak of graph corresponds to the spectral peak frequency
% % which has been set
% [pks,locs] = findpeaks(S);
% 
% disp([w(locs),wp])

end