function [years,nr_obs] = years_with_swell()
% fetching Hs (total sea)
fid = fopen('Heidrun_WAM10_6529N_0732E.txt','r');
A = fscanf(fid,'%f %f %f %f %*f %*f %f %*f %*f %*f %*f %*f %*f %*f %*f %*f %*f',[5,inf])';
fclose(fid);

year = A(:,1); month = A(:,2); hs = A(:,5); nr_obs = length(hs);

% fetching hs,tp and direction on wind sea and swell
fid = fopen('wind_and_swell_sea_tp_mod.txt','r');
B = fscanf(fid,'%f %f %f %f %f %f',[6,inf])';
fclose(fid);

wind_sea_hs = B(:,1); wind_sea_tp = B(:,2); wind_sea_dir = B(:,3);
swell_hs = B(:,4); swell_tp = B(:,5); swell_dir = B(:,6);

nr_of_years = 58; 
years = cell(nr_of_years,12);

j = 1;
first_iteration = 1;
table = zeros(300,7);
for i = 1:nr_obs
    if first_iteration == 1
            first_iteration = 0;
            table(j,1) = hs(i);
            table(j,2) = wind_sea_hs(i);
            table(j,3) = wind_sea_tp(i);
            table(j,4) = wind_sea_dir(i);
            table(j,5) = swell_hs(i);
            table(j,6) = swell_tp(i);
            table(j,7) = swell_dir(i);
            count = 1;
    else
        this_month = month(i);
        last_month = month(i-1);
        this_year = year(i);
        last_year = year(i-1);
        if last_month == this_month
            if (count+1) == nr_obs 
                j = j+1;
                count = count + 1;
                table(j,1) = hs(i);
                table(j,2) = wind_sea_hs(i);
                table(j,3) = wind_sea_tp(i);
                table(j,4) = wind_sea_dir(i);
                table(j,5) = swell_hs(i);
                table(j,6) = swell_tp(i);
                table(j,7) = swell_dir(i);
                years{(this_year-1956),this_month} = table;
            else
                j = j+1;
                count = count + 1;
                table(j,1) = hs(i);
                table(j,2) = wind_sea_hs(i);
                table(j,3) = wind_sea_tp(i);
                table(j,4) = wind_sea_dir(i);
                table(j,5) = swell_hs(i);
                table(j,6) = swell_tp(i);
                table(j,7) = swell_dir(i);
            end
        else
            years{(last_year-1956),last_month} = table;
            
            table = zeros(300,7); 
            j = 1;
            count = count + 1;
            table(j,1) = hs(i);
            table(j,2) = wind_sea_hs(i);
            table(j,3) = wind_sea_tp(i);
            table(j,4) = wind_sea_dir(i);
            table(j,5) = swell_hs(i);
            table(j,6) = swell_tp(i);
            table(j,7) = swell_dir(i);
        end
    end
end
        
nr = 0;
for i = 1:nr_of_years
    for j = 1:12
        table = years{i,j};
        if isempty(table) == 1
        else
            col = table(:,1);
            for k = 1:length(col)
                if ~any(col(k))
                else
                    nr = nr + 1;
                end
            end
        end
    end
end

if nr ~= nr_obs
    disp('Missing data')
else
    disp('All entries in Hindcast data read and sorted')
end

end

